#version 120
// (C) Dmytry Lavrov. All rights reserved.

uniform vec3 brightness;
uniform vec3 stripe_brightness;

// uniform float time; // unused

uniform float sharpness;

uniform mat4 stripe_matrix;

float Peak2(float x, float sb){
	return 1.0+sb*sharpness/(0.5+(0.5-sharpness)*sin(x));
}

void main(void)
{
   //vec4 camera_pos = gl_ModelViewMatrixInverse[3];
  vec4 pos = gl_ModelViewProjectionMatrix * gl_Vertex;
   //vec3 delta=gl_Vertex.xyz-camera_pos.xyz;
	vec3 delta=(gl_ModelViewMatrix*gl_Vertex).xyz;

	float l=dot(delta,delta);
	gl_Position=pos;
	float q=exp2(255.0*gl_Color.a-119.0);

	vec3 col=gl_Color.rgb*(q/l);

	vec3 stripe_pos=(stripe_matrix*gl_Vertex).xyz;

	vec3 stripe_color=vec3(Peak2(stripe_pos.x, stripe_brightness.r), Peak2(stripe_pos.y, stripe_brightness.g), Peak2(stripe_pos.z, stripe_brightness.b));
	float stripe_color_sum=stripe_color.r+stripe_color.g+stripe_color.b;
	stripe_color+=vec3(0.1*stripe_color_sum);

	col*=stripe_color;

	gl_FrontColor=vec4(brightness*col,1.0);
}
