#version 120
// (C) Dmytry Lavrov. All rights reserved.

uniform vec3 brightness;
uniform float stripe_brightness;

// uniform float time; // unused

uniform float sharpness;

uniform mat4 stripe_matrix;

float PeakFunc(float x, float min_y, float max_y, float sharpness){
	return min_y+pow(x,sharpness)*(max_y-min_y);
}

float Peak2(float x){
	return 1.0+stripe_brightness*10.0*sharpness/(0.5+(0.5-sharpness)*sin(x));
}

void main(void)
{
   //vec4 camera_pos = gl_ModelViewMatrixInverse[3];
  vec4 pos = gl_ModelViewProjectionMatrix * gl_Vertex;
   //vec3 delta=gl_Vertex.xyz-camera_pos.xyz;
	vec3 delta=(gl_ModelViewMatrix*gl_Vertex).xyz;

	float l=dot(delta,delta);
	gl_Position=pos;
	float q=exp2(255.0*gl_Color.a-119.0);

	vec3 col=gl_Color.rgb*(q/l);

	vec3 stripe_pos=(stripe_matrix*gl_Vertex).xyz;

	col.r*=Peak2(stripe_pos.x);
	col.g*=Peak2(stripe_pos.y);
	col.b*=Peak2(stripe_pos.z);

	gl_FrontColor=vec4(brightness*col,1.0);
}
